"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.classes = void 0;
const classes = (...expressions) => {
    return expressions
        .map(expr => {
        if (typeof expr === 'string') {
            return expr;
        }
        return Object.entries(expr)
            .filter(([_, condition]) => condition)
            .map(([className, _]) => className)
            .join(' ');
    })
        .join(' ');
};
exports.classes = classes;
